jpress v4.2.2:
新增：文章面包屑指令 #articleCrumb
新增：新增输出指令 #unescape
优化：升级 JFinal/Jboot 等相关依赖到最新版本
修复：JPress 内置代码生成器UI生成器路径错误的bug，感谢 @AlienJunX
修复：Vditor 走的 CDN 国内无法使用的问题



jpress v4.2.1:
新增：模板共享方法新增 unescape 方法
优化：增强微信插件稳定性，保证各个插件运行不会相互影响
优化：升级 JFinal/Jboot 等依赖到最新版本
修复：文章分类创建的时候，固定链接可能重复的问题
修复：文章列表的筛选分类，不显示层级的问题
修复：文章列表的选择每页分页数据量后，出错的问题
修复：后台文字的个别错别字的问题
修复：插件动态升级后，跳转页面错误的问题
修复：登录密码被转义导致个别特殊密码不能正常登录的问题
修复：文章/产品 的详情页无法获取其全部配图的问题
修复：因升级 Jboot 到最新版本后，导致无法正常安装 JPress 的问题



jpress v4.2.0:
新增：添加后台验证码开关，方便在某些场景下进行自动化测试
新增：支持发布0元的商品，支付金额为 0 时，直接支付成功，感谢 @AlienJunX
新增：插件安装目录自定义的功能，方便安装插件后，在编译清空 target 目录时，插件仍然可用
优化：完善文章模块添加收藏功能，感谢 @吓死猫的老鼠
优化：Option 系统配置允许传入空数据，用于清空配置
优化：调整上传默认附件大小，图片默认为 10MB，其他文件默认为 100MB
优化：升级 Jboot、Log4j2 等到最新版本
修复：后台自定义非法关键字无效的问题
修复：通过 API 删除 Option 可能不及时生效的问题
修复：插件依赖外部 jar ，在某些情况下可能会导致无法被安装的问题
修复：微信 H5 支付成功返回页面后出现 500 错误，感谢 @AlienJunX
修复：文章插入附件，当出现附件文件过大错误时，页面没有提示的问题
修复：CKEditor 编辑器 图片无法粘贴上传的问题



jpress v4.1.5:
新增：文章、页面、产品编辑器新增选择附件的功能，可以直接插入附件、图片和视频
优化：加强对 xss 的防护，默认启用全局 xss 拦截
优化：输入选择框 'form-control-clear' 的样式
优化：优化许些提示文字，使之更加友好
修复：选择用户弹出页面，输入关键字搜索时 404 的问题
修复：JPress 弹出 layer 无法上下滚动的问题
修复：#defaultMenu() 指令三级以上菜单无法打开的问题
修复：后台 Dashboard 移动评论到垃圾箱出错的问题



jpress v4.1.4:
新增：新增 ProductCategoryService.findOrCreateByCategoryString() 方法，便于批量发布商品时，新建商品分类。感谢 @吓死猫的老鼠
优化：修改 package.xml 注释的文字错误，感谢 @yueyang
优化：优化微信配置相关的代码，减少不必要的 Java 反射。感谢 @AlienJunX
修复：商品模块选择状态时，出现错误的问题。感谢 @吓死猫的老鼠
修复：预支付时，微信通知方法调用错误而无法通知的问题。感谢 @AlienJunX
修复：修复 log4j2 文件配置错误的问题。@AlienJunX



jpress v4.1.3:
优化：重构 SortModel 以及代码生成器
优化：优化系统设置的菜单名称
优化：CKEditor 编辑器添加图片和表格更多的属性操作
优化：CKEditor 添加对其方式按钮
优化：CKEditor 新增 html 源码编辑的功能
修复：JPress 模块代码生成器生成的目录错误的问题
修复：CKEditor 复制记事本、wps 等内容到编辑器可能出错的问题
修复：WordPress 导入时，可能存在的安全问题



jpress v4.1.2:
优化：升级 Layer 到最新版本
优化：优化产品，修改 Slug 为 "固定链接"
优化：后台菜单的 id 不显示的问题
优化：升级 Jboot 到最新版本
修复：固定链接可以填写纯数字的问题
修复：重命名类名 stringSplit 为 StringSplitDirective
修复：会员设置无法弹出选择 layer 的问题
修复：后台支付相关的页面，个别错位的问题
修复：在某些场景下，用户退出登录出现csrf token 错误的问题



jpress v4.1.1:
新增：后台和用户中心菜单的启用配置功能，可以通过其关闭某些菜单
优化：文章分类、文章、产品分类、产品和页面的模板选择
修复：微信页面无法正常支付的问题
修复：在某些情况下，非完整的 html 无法原样输出的问题
修复：微信小程序 API 应该是当 unioinid 不为空时才会去写入 unioinid，感谢 @喜欢吃豆包
修复：第三方登录 或者 微信授权无法进行登录的问题



jpress v4.1.0:
优化：升级 Jboot、Jfinal 等到最新版本
修复：文章输入多个标签的时候，存入数据库保存的标签错误的问题
修复：文章、商品新建时，若保存两次会导致创建日期被清空的问题
修复：页面二次编辑时，状态设置错误的问题



jpress v4.0.9:
新增：文章编辑新增上传视频的功能
新增：新增 html2wxml 的 api 及其文档
优化：更新文章、产品、页面的 api 以及文档
优化：完善产品、购物车、优惠券的相关 API
修复：文章编辑器 标题 和 加粗无效的问题
修复：在 JPress 导入 eclipse 后，在某些情况下得到的资源路径错误的问题
修复：Menu.isUrlEquals 在二级目录下可能判断不正确的问题
修复：小程序用户未登录时无法获取option信息，提示信息有误
修复：关闭验证码后，后台登录验证码输入框不显示的问题



jpress v4.0.8:
新增：插件新增 @Path() @GetMapping() @PostMapping() 的支持
新增：插件新增 @ActionKey() 注解配置相对路径配置的支持
优化：升级 JFinal 和 Jboot 到最新版本
优化：优化模板的后台设置页面
优化：修改带有错别字的方法名
优化：验证码输入框添加 autocomplete="off" 属性
修复：插件开发时，在某些情况下后台可能无法显示插件菜单的问题
修复：验证码在某些情况下出现异常的问题
文档：完善微信小程序用户登录、注册、获取手机号的相关 API 及其文档
文档：完善模板开发的相关文档
文档：完善微信的相关文档
文档：完善用户的相关文档
文档：完善设置的相关文档



jpress v4.0.7:
优化：一键安装脚本，方便阿里云和腾讯云等服务器进行一键安装
优化：升级 Jboot JFinal 到最新版本
优化：日志框架由 logback 切换到 log4j2，性能更高
修复：文章和产品搜索引擎切换到 es 的时候可能出错的问题
修复：setting_v4.html 不能使用的问题
修复：ElasticSearch 在 Mysql8 下更新文章会导致类型出错的问题
文档：完善系统配置的 Http API 相关文档和单元测试用例
文档：完善用户 Http API 相关的文档和单元测试用例
文档：完善文章相关 Http API 相关的文档和单元测试用例
文档：完善 API 签名算法的相关文档



jpress v4.0.6:
新增：模板编辑、文章编辑、页面编辑、产品编辑 的快捷键保存功能
新增：文章和产品搜索引擎的高亮显示...
新增：文章搜索引擎和产品搜索引擎切换后，自动重建搜索引擎的索引功能
优化：重构 product-provider 模块的包结构
修复：开启文章 Lucene 搜索引擎后，导致 elastic 包冲突的而造成 NoClassDefFoundError 的异常问题
修复：开启扁平化 URL 后，个别菜单可能无法正常高亮的问题



jpress v4.0.5:
优化：获取当前页面的分页页码的代码
修复：用户中心非管理员账户无法查看内容和投稿的问题
修复：calmlog 模板的页面评论会产生 2 此评论的问题
修复：文章页面的评论 pageNumber 获取错误的问题
修复：用户注册时可能出现返回 json 内容，而未跳转登录页面的问题



jpress v4.0.4:
新增：articles 路径的支持，用于渲染 "所有文章"
新增：products 路径的支持，用于渲染 "所有产品"
优化：增强文章、产品以及分类的固定连接支持 "-" 字符
优化：产品分类指令 productCategoryList 修改为 allProductCategories
优化：移除 AddonClassPath 的定义，Jboot 已经解决了动态加载的日志问题
优化：删除无用代码、重构 Service 的方法名称、移动 UrlUtils 的类到 utils 包下
优化：弹出的 layer 有小滚动条的问题
修复：后台商品编辑时无法显示最近标签的问题
修复：用户登录页面在某些情况下不跳转用户中心的问题
修复：用户中心下拉的购物车列表的产品无法点击的问题
修复：用户中心里，用户无法对产品评论进行删除的问题
修复：当开启扁平化 URL 后，文章详情、产品详情和页面的评论分页 URL 不正确的问题
修复：文章 tag 的 url 错误的问题



jpress v4.0.3:
修复：设置伪静态后缀后，重启失效的问题
修复：后台启用第三方登录后，默认登录页面 UI 错位的问题
修复：自定义后台登录地址时，后台无法登录的问题
修复：git 上还保存着大写的 AdminLTE.min.css 的问题
修复：JPress初始化时可能的一些安全问题
修复：某些页面出现 js 错误的问题
修复：docker-compose.yml 版本号错误的问题



jpress v4.0.2:
优化：安装时，某些 UI 细节错位的问题
优化：开启伪静态后，若没有填写后缀，默认后缀为 .html
优化：评论框以及前台导航菜单的样式细节
修复：在 tomcat 二级目录下，登录的验证码不能正确显示的问题
修复：后台的某些菜单无法显示的问题
修复：角色和会员组的编辑按钮 404 的问题
修复：后台开启 扁平化 URL 不起作用的问题
修复：文档中 git 路径错误的问题



jpress v4.0.1:
新增：用户中心财务和个人信息菜单可以通过 MenuManager 进行管理的功能，方便插件化定制
优化：优化 CKEditor5 编辑器，移除一些不必要的插件和新增code插件
优化：所有的 Module 应该继承 ModuleBase
修复：安装模版之后，跳转模版页面错误的问题。close #I3UKIF
修复：模板编辑不能保存的问题。close #I3UJAX
修复：文章列表页>点击文章标题>跳到新增页面去了。close #I3UJAW
修复：文章编辑、产品编辑页面的时间选择组件无法正确弹出的问题。
修复：在安装页面 AdminLTE.min.css 引用路径错误的问题



jpress v4.0.0:
新增：模板预览功能，自由在后台开启或关闭
新增：#@defaultMenu() 指令，更加方便用于渲染前台菜单
新增：登录开启验证码功能，默认为开启
新增：扁平化 URL 功能开关的功能，更加有利于 SEO，例如 /article/category/1.html 为 /article-category-1.html
新增：全新的图片选择组件，日期组件的前端 UI 组件
新增：全新的选择用户的 input 组件
新增：AddonBase 类，方便用户编写 插件 入口类
新增：模板的后台设置新增 setting_v4.html 的支持
优化：升级 AdminLte 和 Bootstrap 到最新版本
优化：升级 fontawesome 到最新版本
优化：删除 ckeditor4 和 simplemde，使用 ckeditor5 和 vditor 代替
优化：DatetimeRender 组件，时间相关的弹出UI更加简洁
优化：合并 article.js、product.js、page.js 到 jpressfront.js
优化：合并 article.css、product.css、page.css 到 jpressfront.css
优化：管理员重置用户密码不再需要原密码
优化：全面优化 layer 弹出的相关 UI
优化：优化 JPress 内置的 4 套模板 UI 细节
优化：后台相关必填输入框添加相关前端验证
优化：微信相关功能的 url 目录结构
优化：优化 logback 的日志输出目录结构
优化：重构 jpress maven 目录，修改 service-api 为 service
优化：后台评论列表页面，新增根据用户搜索的功能
优化：附件选择功能，增加可以选择每页数量的选择
修复：v3.x 发布评论的头像显示不正确的问题
修复：v3.x page 评论分页 404 的问题
修复：v3.x 后台的评论列表新增 待审核 的 tab 标签不显示的问题
修复：v3.x 页面修改后，SEO Ping 出错的问题
修复：v3.x 企业版在某些配置不能同步到其他分布式节点的问题


